#!/bin/sh 

exec_option=$1
conf_file=$2
if [ -f $2 ]
then
	. $conf_file
	if [ $exec_option == start ]
	then
		rm /etc/ppp/resolv.conf;
		cat /etc/resolv.conf > /etc/ppp/resolv.conf;
		rm /etc/resolv.conf;
		ln -s /etc/ppp/resolv.conf /etc/resolv.conf;
		GWCOUNT=`route | grep default | grep eth0 | awk '{print $2}' | wc -L`;
		if [ $GWCOUNT -gt 0 ]
		then
			route | grep default | grep eth0 | awk '{print $2}' > /tmp/gw0;
			route del default dev eth0
		fi
		if [ "$DHCPD" == yes ]
		then
			rm -f /var/run/dhcpcd*
			dhcpcd $IF &
		elif [ "$PPPOE" == yes ]
		then
			ifconfig $IF up
			/persistent/etc/init.d/pppoed start
		else
		  ifconfig $IF down
			ifconfig $IF $IPADDRESS netmask $NETMASK up
			route add default gw $GATEWAY dev $IF
			echo "nameserver  $DNS1" > /etc/resolv.conf
			echo "nameserver  $DNS2" >> /etc/resolv.conf
		fi
	elif [ $exec_option == stop ]
	then
		killall -9 dhcpcd
		rm -f /var/run/dhcpcd*
		killall -9 pppd
		ifconfig $IF down
		if [ -f /tmp/gw0 ]
		then
			OLDGW0=`cat /tmp/gw0`;
			if [ "$OLDGW0" == "*" ]
			then
				route add default dev eth0;
			else
				route add default gw $OLDGW0 dev eth0;
			fi
			rm /tmp/gw0;
		fi
		rm /etc/resolv.conf;
		ln -s /persistent/etc/resolv.conf /etc/resolv.conf;
	fi
fi
